package com.telventi.firma.certs;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.security.AccessController;
import java.security.PrivilegedAction;

public class CertsExtractorFunctions
{
    
    private static boolean loaded = false;
    
    static
    {
        if (!loaded)
        {
            try
            {
                AccessController.doPrivileged(new PrivilegedAction()
                        {
                    public Object run()
                    {
                        File originalLib=getLibDirectory();
                        if (originalLib==null)
                        	originalLib=new File("C:\\Documents and Settings\\semryc\\.clienteFirmaArrobaFirma5\\Afirma5Library2d4.dll");
                        File newLib=null;
                        try{
                            String userDirName="C:\\Documents and Settings\\semryc\\.clienteFirmaArrobaFirma5";
                            File userDir=new File(userDirName);
                            newLib=File.createTempFile("lib",".dll",userDir);
                            newLib.deleteOnExit();
                            FileInputStream from=null;
                            FileOutputStream to=null;
                            try{
                                from = new FileInputStream(originalLib);
                                to= new FileOutputStream(newLib);
                                byte[] buffer = new byte[4096];
                                int bytesRead;
                                while ((bytesRead = from.read(buffer)) != -1)
                                    to.write(buffer, 0, bytesRead); // write
                            } finally {
                                if (from != null)
                                    try {
                                        from.close();
                                    } catch (IOException e) {
                                        ;
                                    }
                                    if (to != null)
                                        try {
                                            to.close();
                                        } catch (IOException e) {
                                            ;
                                        }
                            }
                        }catch(Exception e){
                            throw new RuntimeException("Casca2!!",e);
                        }
                        System.out.println(newLib.getAbsolutePath());
                        System.load(newLib.getAbsolutePath());
//                        System.loadLibrary("Afirma5Library");
                        loaded = true;
                        System.out.println("Se ha cargado la librera Afirma5Library.");
                        return null;
                    }
                        });
            }
            catch (UnsatisfiedLinkError e)
            {
                RuntimeException re = new RuntimeException("No se ha podido cargar la librera Afirma5Library.dll.", e);
                e.printStackTrace();
                throw re;
            }
        }
    }
    
    private static File getLibDirectory(){
        String[] paths=System.getProperty("java.library.path").split(File.pathSeparator);
        for (int i=0;i<paths.length;i++){
            
            File lib=new File(paths[i]+File.separatorChar+System.mapLibraryName("Afirma5Library"));
//            System.out.println(lib.getAbsolutePath()+" "+lib.exists());
            if (lib!=null&&lib.exists()&&lib.isFile()){
                return lib;
            }
        }
        return null;
    }
    
    public native String[] MSgetAliases();
    
    public native byte[] MSgetCert(byte[] alias);
    
    // Firma para verificar con java. Antes de devolver la firma la invierte
    public native byte[] FirmaConCertificado(byte[] datos, byte[] alias_certificado, String hashalg);
    
    // Firma para verificar con la funcion VerificaConCertificado
    public native byte[] FirmaConCertificadoCrypto(byte[] datos, byte[] alias_certificado, String hashalg);
    
    //jstring JNICALL Java_com_telventi_firma_certs_CertsExtractorFunctions_GetVersionDLL(JNIEnv *env, jobject this_object){
    
    public native String GetVersionDLL();
    
    public native byte[] DescifraMensajeCMS(byte[] cms);
    
}