package com.telventi.firma.certs;

import java.security.AccessController;
import java.security.PrivilegedAction;


public class CertsExtractorFunctions2
{
//    protected static final AppletLogger logger = new AppletLogger("CertsExtractorFunctions2", AppletLogger.INFO);

    private static boolean loaded = false;

    static
    {
        if (!loaded)
        {
            try
            {
                AccessController.doPrivileged(new PrivilegedAction()
                {
                    public Object run()
                    {
                        System.loadLibrary("appletAFirma3");
                        loaded = true;
//                        logger.log(AppletLogger.INFO, "Se ha cargado la librera appletAFirma3.");
                        System.out.println("Se ha cargado la librera appletAFirma.");
                        return null;
                    }
                });
            }
            catch (UnsatisfiedLinkError e)
            {
                RuntimeException re = new RuntimeException("No se ha podido cargar la librera appletAfirma.dll.", e);
//                logger.log(AppletLogger.FATAL, re);
                System.err.println("FATAL ERROR: "+re.getMessage());
                throw re;
            }
        }
    }


    public native String[] MSgetAliases();

    public native byte[] MSgetCert(byte[] alias);

    // Firma para verificar con java. Antes de devolver la firma la invierte
    public native byte[] FirmaConCertificado(byte[] datos, byte[] alias_certificado, String hashalg);

    // Firma para verificar con la funcion VerificaConCertificado
    public native byte[] FirmaConCertificadoCrypto(byte[] datos, byte[] alias_certificado, String hashalg);

    // NOTA: SE Distingue entre esas dos funciones porque cuando firmas con
    // crypto api
    // devuelve la firma al reves => para verificar con java hay que invertirla.
    // Sin embargo
    // si queremos verificar con crypto api no debemos invertirla porque el la
    // espera como la firma,
    // es decir al reves

    public native boolean VerificaConCertificado(byte[] datos, byte[] firma, byte[] alias_certificado, String hashalg);

    //jstring JNICALL Java_com_telventi_firma_certs_CertsExtractorFunctions_GetVersionDLL(JNIEnv *env, jobject this_object){
 
    public native String GetVersionDLL();
    
}