package ee.sk.digidoc;

import nu.xom.Attribute;
import nu.xom.Element;
import ee.sk.digidoc.utils.XMLObject;

public class DataObjectFormat extends XMLObject {
	private String m_description;
	private String m_oid;
	private String m_mimetype;
	private String m_encoding;
	private Reference m_objectReference;
	
	public DataObjectFormat(Reference objectReference) {
		m_description = null;
		m_oid = null;
		m_mimetype = null;
		m_encoding = null;
		m_objectReference=objectReference;
	}
	
	public DataObjectFormat(String description, String encoding, String mimetype, String oid,Reference reference) {
		this.m_description = description;
		this.m_encoding = encoding;
		this.m_mimetype = mimetype;
		m_objectReference = reference;
		this.m_oid = oid;
	}

	public String getDescription() {
		return m_description;
	}

	public void setDescription(String description) {
		this.m_description = description;
	}

	public String getEncoding() {
		return m_encoding;
	}

	public void setEncoding(String encoding) {
		this.m_encoding = encoding;
	}

	public String getMimetype() {
		return m_mimetype;
	}

	public void setMimetype(String mimetype) {
		this.m_mimetype = mimetype;
	}

	public Reference getObjectReference() {
		return m_objectReference;
	}

	public void setObjectReference(Reference reference) {
		m_objectReference = reference;
	}

	public String getOID() {
		return m_oid;
	}

	public void setOID(String oid) {
		this.m_oid = oid;
	}

	protected Element createElement() throws DigiDocException{
		throw new DigiDocException(DigiDocException.ERR_XML_CONVERT,"Cannot create element without specific namespace",null);
	}
	
	protected Element createElement(String namespace) throws DigiDocException{
		if(thisObject==null){
			if(m_objectReference != null&&
					(m_objectReference!=null||
							m_encoding!=null||
							m_oid!=null||
							m_description!=null)) {
				thisObject=makeEasyElement("DataObjectFormat",namespace);
			}else {
				throw new DigiDocException(0,"Error",new NullPointerException());
			}
		}
		if(m_objectReference!=null) {
			if(m_description != null) {
				if (thisObject.getChildElements("Description",namespace).size()>0)
					thisObject.removeChild(thisObject.getChildElements("Description",namespace).get(0));
				Element description=makeEasyElement("Description",namespace);
				description.appendChild(m_description);
				thisObject.appendChild(description);
			}
			if(m_encoding != null) {
				if (thisObject.getChildElements("Encoding",namespace).size()>0)
					thisObject.removeChild(thisObject.getChildElements("Encoding",namespace).get(0));
				Element encoding=makeEasyElement("Encoding",namespace);
				encoding.appendChild(m_encoding);
				thisObject.appendChild(encoding);
			}
			if(m_mimetype != null) {
				if (thisObject.getChildElements("MimeType",namespace).size()>0)
					thisObject.removeChild(thisObject.getChildElements("MimeType",namespace).get(0));
				Element mimetype=makeEasyElement("MimeType",namespace);
				mimetype.appendChild(m_mimetype);
				thisObject.appendChild(mimetype);
			}
			if(m_oid != null) {
				if (thisObject.getChildElements("ObjectIdentifier",namespace).size()>0)
					thisObject.removeChild(thisObject.getChildElements("ObjectIdentifier",namespace).get(0));
				Element oid=makeEasyElement("ObjectIdentifier",namespace);
				oid.appendChild(m_oid);
				thisObject.appendChild(oid);
			}
			thisObject.addAttribute(new Attribute("ObjectReference","#"+m_objectReference.getId()));
		}
		return thisObject;
	}

}
