package ee.sk.digidoc.factory;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;

import nu.xom.Builder;
import nu.xom.Document;
import nu.xom.Element;
import nu.xom.ParsingException;
import nu.xom.ValidityException;
import nu.xom.canonical.Canonicalizer;
import ee.sk.digidoc.DigiDocException;

public class XOMCanonicalizationFactory implements CanonicalizationFactory {

	
	private Canonicalizer canonicalizer=null;
	
	public XOMCanonicalizationFactory() {
	}
	
	private static Builder builder;
	
	static{
		try{
			builder=XOMBuilderFactory.getInstance(false);
		}catch(Exception e){
			;
		}
	}

	public void init() throws DigiDocException {
		
	}

	public byte[] canonicalize(Element node, String method) throws DigiDocException{
		ByteArrayOutputStream baos=new ByteArrayOutputStream();
//		canonicalizer=new Canonicalizer(baos,Canonicalizer.CANONICAL_XML_WITH_COMMENTS);
		canonicalizer=new Canonicalizer(baos,Canonicalizer.EXCLUSIVE_XML_CANONICALIZATION);
		try{
			canonicalizer.write(node);
		} catch (IOException e) {
			throw new DigiDocException(DigiDocException.ERR_CAN_ERROR,"Error reading input data",e);
		}
		byte[] output=baos.toByteArray();
		return output;
	}
	
	public byte[] canonicalize(byte[] data, String uri) throws DigiDocException {
		ByteArrayOutputStream baos=new ByteArrayOutputStream();
//		canonicalizer=new Canonicalizer(baos,Canonicalizer.CANONICAL_XML_WITH_COMMENTS);
		canonicalizer=new Canonicalizer(baos,Canonicalizer.EXCLUSIVE_XML_CANONICALIZATION);
		try {
			Document document=builder.build(new ByteArrayInputStream(data));
			canonicalizer.write(document);
		} catch (ValidityException e) {
			throw new DigiDocException(DigiDocException.ERR_CAN_ERROR,"Error validating input data",e);
		} catch (ParsingException e) {
			throw new DigiDocException(DigiDocException.ERR_CAN_ERROR,"Error parsing input data",e);
		} catch (IOException e) {
			throw new DigiDocException(DigiDocException.ERR_CAN_ERROR,"Error reading input data",e);
		}
		byte[] output=baos.toByteArray();
		
		return output;
	}

}
