package ee.sk.digidoc.utils;

import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.util.Random;

public final class UUIDUtils{

    private static final char[] HEX_CHARS =
        {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};
    
    
    
    public static String generateUUID(){
        Random rnd = null;
		try {
			rnd = SecureRandom.getInstance("SHA1PRNG");
		} catch (NoSuchAlgorithmException e) {
			System.out.println("No se ha obtenido la instancia para generar identificadores de elementos.");
			e.printStackTrace();
		}
        byte[] rndBuffer=new byte[8];
        rnd.nextBytes(rndBuffer);
        StringBuffer tmpUid=new StringBuffer(new String(encodeHex(rndBuffer)));
        tmpUid.insert(4, '-');
        tmpUid.insert(9, '-');
        tmpUid.insert(14, '-');
        
        return tmpUid.toString();
    }
    
//    public static String generateUUID(int count,int test){
//        String res="-Id-"+test+"-"+count;
//        return res;
//    }
    
    private static char[] encodeHex(byte[] data)
    {
        int l = data.length;
        char[] out = new char[l << 1];
        for (int i = 0, j = 0; i < l; i++){
            out[j++] = HEX_CHARS[(0xF0 & data[i]) >>> 4];
            out[j++] = HEX_CHARS[0x0F & data[i]];
        }
        return out;
    }
    
}
