package test;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.security.KeyStore;
import java.security.PrivateKey;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import java.util.Enumeration;

import nu.xom.Document;
import nu.xom.Serializer;
import sun.misc.HexDumpEncoder;
import ee.sk.digidoc.CertValue;
import ee.sk.digidoc.Content;
import ee.sk.digidoc.DigiDocException;
import ee.sk.digidoc.Signature;
import ee.sk.digidoc.SignatureProductionPlace;
import ee.sk.digidoc.SignedDoc;
import ee.sk.digidoc.utils.Base64;

public class test2 {
	public static String data="T3st1ng d4t4...";
	static String encoding="UTF-8";
	private static String password="1111";
	
	public static void main(String[] args) {
		HexDumpEncoder hde=new HexDumpEncoder();
		try {
			byte[] dataBytes=data.getBytes(encoding);
			String base64=Base64.encodeBytes(dataBytes);
			System.out.println(base64);
		}catch(Exception e) {
			e.printStackTrace();
			return;
		}
		
		int choosen=0;
		String alias=null;
		X509Certificate[] certs=null;
		KeyStore ks;
		try{
			ks=KeyStore.getInstance("PKCS12");
			ks.load(new FileInputStream("C:\\InitialPackage\\CryptographicMaterial\\SCOK\\SigningUserOK.p12"),password.toCharArray());
//			ks.load(new FileInputStream("C:\\InitialPackage\\CryptographicMaterial\\SC1\\RevokedSigningUserOK.p12"),password.toCharArray());
			Enumeration e=ks.aliases();
			
			while(e.hasMoreElements()) {
				alias=(String)e.nextElement();
				System.out.println("Certificado encontrado "+alias);
			}
			byte certB[]=ks.getCertificate(alias).getEncoded();
			CertificateFactory cf=CertificateFactory.getInstance("X509");
			certs=new X509Certificate[]{(X509Certificate)cf.generateCertificate(new ByteArrayInputStream(certB))};
		}catch(Exception e){
			e.printStackTrace();
			return;
		}
		
		SignedDoc doc;
		Signature sig;
		byte[] si;

		try {
			
			doc = new SignedDoc(SignedDoc.FORMAT_XAdES_1_3_2,SignedDoc.VERSION_1_0,SignedDoc.MODE_ENVELOPING_SIGNATURE);
			Content cont=doc.setContent(data.getBytes(encoding),"CONTENT","text/plain");
			cont.setDataEncoding(encoding);
			SignatureProductionPlace place=new SignatureProductionPlace("Sevilla",null,"Spain",null);
			String role=
				"<xl:XadesLabs xmlns:xl=\"http://xadeslabs.com/xades\"> \r\n" + 
				"    <xl:Roles type=\"signer\">\r\n" + 
				"		<xl:ExecutiveDirector>true</xl:ExecutiveDirector>\r\n" + 
				"		<xl:ShareHolder>true</xl:ShareHolder>\r\n" + 
				"		<xl:Vendor>false</xl:Vendor>\r\n" + 
				"		<xl:Purchaser>false</xl:Purchaser>\r\n" + 
				"		<xl:Engineer>flase</xl:Engineer>\r\n" + 
				"	</xl:Roles>\r\n" + 
				"</xl:XadesLabs>";
//			sig = doc.prepareSignature(certs[choosen],new String[] {role},place);
//			sig = doc.prepareSignature(certs[choosen],new String[] {role},null);
//			sig = doc.prepareSignature(certs[choosen],new String[] {},place);
			sig = doc.prepareSignature(certs[choosen],new String[] {},null);
			si=sig.getSignedInfo().toCanonicalXML();
			try{
				java.security.Signature signature1=java.security.Signature.getInstance("SHA1withRSA");
				signature1.initSign((PrivateKey) ks.getKey(alias,password.toCharArray()));
				signature1.update(si);
				byte[] signed=signature1.sign();
				sig.setSignatureValue(signed);
			}catch(Exception e){
				e.printStackTrace();
				return;
			}
			try {
				java.security.Signature signature=java.security.Signature.getInstance("SHA1withRSA");
				signature.initVerify(sig.getCertValueOfType(CertValue.CERTVAL_TYPE_SIGNER).getCert());
				signature.update(sig.getSignedInfo().toCanonicalXML());
				boolean ok=signature.verify(sig.getSignatureValue().getValue());
				System.out.println("FIRMA "+(ok?"VALIDA":"INVALIDA"));
			} catch (Exception e) {
				e.printStackTrace();
			}
			Document d=doc.getXML();
			ByteArrayOutputStream baos=new ByteArrayOutputStream();
			FileOutputStream fos=new FileOutputStream(new File("C:/encoding.xml"));
			Serializer serializer=new Serializer(baos,encoding);
			serializer.write(d);
			byte[] out=baos.toByteArray();
			
			
			fos.write(out);
			fos.close();
			baos.close();
			System.out.println("Firma lista!");
			
			byte[] toSign=SignedDoc.prepareCounterSign(out, null, certs[choosen]);
			try{
				byte[] signed;
				java.security.Signature signature1=java.security.Signature.getInstance("SHA1withRSA");
				signature1.initSign((PrivateKey) ks.getKey(alias,password.toCharArray()));
				signature1.update(toSign);
				signed=signature1.sign();
				sig.setSignatureValue(signed);
				byte[] counter=SignedDoc.finishCounterSignature(signed);
				FileOutputStream fos2=new FileOutputStream("C:/Signature.xml");
				fos2.write(counter);
				fos2.close();
				System.out.println(new String (counter));
			}catch(Exception e){
				e.printStackTrace();
				return;
			}
//			
//			byte[] toSign=SignedDoc.prepareCoSign(out, data.getBytes(encoding), null, cert);
//			try{
//				byte[] signed;
//				signed=dll.FirmaConCertificado(toSign,alias.getBytes(), "SHA1");
//				byte[] counter=SignedDoc.finishCoSignature(signed);
//				FileOutputStream fos2=new FileOutputStream("C:/Signature.xml");
//				fos2.write(counter);
//				fos2.close();
//				System.out.println(new String (counter));
//			}catch(Exception e){
//				e.printStackTrace();
//				return;
//			}
		} catch (DigiDocException e) {
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
}